#!/usr/bin/perl  -w

#main program
#This program is invoked in each subject's directory

$data_file_name = "data.tex";

$max_iteration = 2;

%total_tests = ();
%total_methodexecs = ();

%frontend_has_results = ();
$frontend_has_results{"pairwiseEquals"}{"TestMin"} = 0;
$frontend_has_results{"monitorEquals"}{"TestMin"} = 0;
$frontend_has_results{"monitorWField"}{"TestMin"} = 0;
$frontend_has_results{"traverseField"}{"TestMin"} = 0;
$frontend_has_results{"monitorSMSeq"}{"TestMin"} = 0;
$frontend_has_results{"monitorSeq"}{"TestMin"} = 0;
$frontend_has_results{"pairwiseEquals"}{"TestGen"} = 0;
$frontend_has_results{"monitorEquals"}{"TestGen"} = 0;
$frontend_has_results{"monitorWField"}{"TestGen"} = 0;
$frontend_has_results{"traverseField"}{"TestGen"} = 0;
$frontend_has_results{"monitorSMSeq"}{"TestGen"} = 0;
$frontend_has_results{"monitorSeq"}{"TestGen"} = 0;

open(DATA, ">".$data_file_name) || die "opening skeleton file".$data_file_name." $!";

while ($name=glob('jias_*.txt')) {
    if ($name=~/^jias_TestMin_results_for_(.+)Test(\d*)_by_(.+)\.txt$/){
		#test minimization result for JCraher generated tests
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $3;
		$class_name = &getNameWithoutPackage($class_name);		
		$frontend_has_results{$frontend_name}{"TestMin"} = 1;
		$test_tool_name = "JCrasher";
		&processMinimizationResultFile($name, $class_name, $frontend_name, $test_tool_name);
    } elsif ($name=~/^jias_TestMin_results_for_(.+)TestAuto_by_(.+)\.txt$/){
		#test minimization result for Jtest generated tests
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $2;
		$class_name = &getNameWithoutPackage($class_name);
		$frontend_has_results{$frontend_name}{"TestMin"} = 1;
		$test_tool_name = "Jtest";
		&processMinimizationResultFile($name, $class_name, $frontend_name, $test_tool_name);
    } elsif ($name=~/^jias_1_TestMin_elapsed_time_for_(.+)Test(\d*)_by_(.+)\.txt$/){
		#test elapsed time  for JCraher generated tests
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $3;
		$class_name = &getNameWithoutPackage($class_name);
		$test_tool_name = "JCrasher";
		&processMinimizationElapsedTimeFile($name, $class_name, $frontend_name, $test_tool_name);
    } elsif ($name=~/^jias_1_TestMin_elapsed_time_for_(.+)TestAuto_by_(.+)\.txt$/){
		#test elapsed time  for Jtest generated tests
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $2;
		$class_name = &getNameWithoutPackage($class_name);
		$test_tool_name = "Jtest";
		&processMinimizationElapsedTimeFile($name, $class_name, $frontend_name, $test_tool_name);
	} elsif ($name=~/^jias_TestGen_results_for_(.+)Test(\d*)_by_(.+)\.txt$/){
		#test minimization result for JCraher generated tests
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $3;
		$class_name = &getNameWithoutPackage($class_name);
		$frontend_has_results{$frontend_name}{"TestGen"} = 1;
		$test_tool_name = "JCrasher";
		&processGenerationResultFile($name, $class_name, $frontend_name, $test_tool_name);
	} elsif ($name=~/^jias_TestGen_results_for_(.+)TestAuto_by_(.+)\.txt$/){
		#test minimization result for Jtest generated tests
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $2;
		$class_name = &getNameWithoutPackage($class_name);
		$frontend_has_results{$frontend_name}{"TestGen"} = 1;
		$test_tool_name = "Jtest";
		&processGenerationResultFile($name, $class_name, $frontend_name, $test_tool_name);
	} 
}

#the following add those OM into the unfound files
print DATA "%the following print out the unfound front end result files:\n";
foreach $frontend_name (keys %frontend_has_results) {	
	if ($frontend_has_results{$frontend_name}{"TestMin"} == 0) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
		print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Time} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Prtests} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Pmmexecs} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Neobjs} {"."om"."}"."\n";
	}
	if ($frontend_has_results{$frontend_name}{"TestGen"} == 0) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOneTime} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOneTests} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOneNeobjs} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwoTime} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwoTests} {"."om"."}"."\n";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwoNeobjs} {"."om"."}"."\n";
	}
	
}
print DATA "\n";

#test type, used in branch cov and exception result processing
$ORIG_TESTS = 0;
$MINIMIZED_TESTS = 1;
$GENERATED_ITERATION_1 = 2;
$GENERATED_ITERATION_2 = 3;

%frontend_has_bcov = ();
$frontend_has_bcov{"pairwiseEquals"}{1} = 0;
$frontend_has_bcov{"monitorEquals"}{1} = 0;
$frontend_has_bcov{"monitorWField"}{1} = 0;
$frontend_has_bcov{"traverseField"}{1} = 0;
$frontend_has_bcov{"monitorSMSeq"}{1} = 0;
$frontend_has_bcov{"monitorSeq"}{1} = 0;
$frontend_has_bcov{"pairwiseEquals"}{2} = 0;
$frontend_has_bcov{"monitorEquals"}{2} = 0;
$frontend_has_bcov{"monitorWField"}{2} = 0;
$frontend_has_bcov{"traverseField"}{2} = 0;
$frontend_has_bcov{"monitorSMSeq"}{2} = 0;
$frontend_has_bcov{"monitorSeq"}{2} = 0;

$iteration1_found = 0;
$iteration2_found = 0;
while ($name=glob('jusc_*.txt')) {
	if ($name=~/^jusc_statistics_(.+)Test1(.*).txt$/){
		#bcov for Jcrasher generated tests and minimized tests		
		print "Processing ".$name."\n";
		$class_name = $1;
		$postfix_name = $2;		
		$test_tool_name = "JCrasher";		
		$class_name = &getNameWithoutPackage($class_name);
		if ($postfix_name=~/^Min(.+)$/) {
			#is minimized tests
			$test_type = $MINIMIZED_TESTS;
			$frontend_name = $1;
		} elsif ($postfix_name=~/^$/) {
			#is original tests
			$test_type = $ORIG_TESTS;
			$frontend_name = "";
		}
		&processBCovExceptionFile($name, $class_name, $frontend_name, $test_tool_name, $test_type);
	} elsif ($name=~/^jusc_statistics_(.+)TestAuto(.*).txt$/){
		#bcov for Jcrasher generated tests and minimized tests		
		print "Processing ".$name."\n";
		$class_name = $1;
		$postfix_name = $2;		
		$test_tool_name = "Jtest";		
		$class_name = &getNameWithoutPackage($class_name);
		if ($postfix_name=~/^Min(.+)$/) {
			#is minimized tests
			$test_type = $MINIMIZED_TESTS;
			$frontend_name = $1;
		} elsif ($postfix_name=~/^$/) {
			#is original tests
			$test_type = $ORIG_TESTS;
			$frontend_name = "";
		}
		&processBCovExceptionFile($name, $class_name, $frontend_name, $test_tool_name, $test_type);
	} elsif ($name=~/^jusc_statistics_(.+)TestGen(.*)1.txt$/){		
		#bcov for generated tests for first iteration
		$iteration1_found = 1;
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $2;
		$class_name = &getNameWithoutPackage($class_name);
		$test_type = $GENERATED_ITERATION_1;
		$frontend_has_bcov{$frontend_name}{1} = 1;
		#we inherit the $test_tool_name from earlier processing
		&processBCovExceptionFile($name, $class_name, $frontend_name, $test_tool_name, $test_type);
	} elsif ($name=~/^jusc_statistics_(.+)TestGen(.+)1(.+)TestGen(.+)2.txt$/){
		#bcov for generated tests for both first and second iteration
		$iteration2_found = 1;
		print "Processing ".$name."\n";
		$class_name = $1;
		$frontend_name = $4;
		$class_name = &getNameWithoutPackage($class_name);
		$test_type = $GENERATED_ITERATION_2;
		$frontend_has_bcov{$frontend_name}{2} = 1;
		#we inherit the $test_tool_name from earlier processing
		&processBCovExceptionFile($name, $class_name, $frontend_name, $test_tool_name, $test_type);
	}
}

#the following add those OM into the unfound files
print DATA "%the following print out the unfound iteration coverage information:\n";
foreach $frontend_name (keys %frontend_has_bcov) {	
	if ($frontend_has_bcov{$frontend_name}{1} == 0) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
		$metrics_type = "BCov";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {"."om"."}"."\n";
		$metrics_type = "Exceptions";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {"."om"."}"."\n";
	}
	if ($frontend_has_bcov{$frontend_name}{2} == 0) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
		$metrics_type = "BCov";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {"."om"."}"."\n";
		$metrics_type = "Exceptions";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {"."om"."}"."\n";
	}
}
print DATA "\n";

print DATA "%the following is for orig table entries in test generation table"."\n";
foreach $frontend_name (keys %frontend_has_bcov) {	
	foreach $name1 (sort {$total_tests{$a} <=> $total_tests{$b}} keys %total_tests) {
		foreach $name2 (sort {$total_tests{$name1}{$a} <=> $total_tests{$name1}{$b}} keys %{$total_tests{$name1}}) {	
			$tname1 = $name1;
			$tname2 = $name2;
			$tname1 =~ s/\.//g;
			$tname2 =~ s/\.//g;
			print DATA "\\newcommand{\\"."testGen".$tname1.$frontend_name.$tname2."OrigTests} {".$total_tests{$name1}{$name2}."}\n";
		}
	}
}  
foreach $frontend_name (keys %frontend_has_bcov) {	
	foreach $name1 (sort {$total_methodexecs{$a} <=> $total_methodexecs{$b}} keys %total_methodexecs) {
		foreach $name2 (sort {$total_methodexecs{$name1}{$a} <=> $total_methodexecs{$name1}{$b}} keys %{$total_methodexecs{$name1}}) {		
			$tname1 = $name1;
			$tname2 = $name2;
			$tname1 =~ s/\.//g;
			$tname2 =~ s/\.//g;
			print DATA "\\newcommand{\\"."testGen".$tname1.$frontend_name.$tname2."OrigMexecs} {".$total_methodexecs{$name1}{$name2}."}\n";
		}
	}
}  
  
  
print DATA "%the following is for subject table"."\n";
foreach $name1 (sort {$total_tests{$a} <=> $total_tests{$b}} keys %total_tests) {
	foreach $name2 (sort {$total_tests{$name1}{$a} <=> $total_tests{$name1}{$b}} keys %{$total_tests{$name1}}) {		
		$tname1 = $name1;
		$tname2 = $name2;
		$tname1 =~ s/\.//g;
		$tname2 =~ s/\.//g;
		print DATA "\\newcommand{\\"."testSubject".$tname1.$tname2."Tests} {".$total_tests{$name1}{$name2}."}\n";
	}
}
foreach $name1 (sort {$total_methodexecs{$a} <=> $total_methodexecs{$b}} keys %total_methodexecs) {
	foreach $name2 (sort {$total_methodexecs{$name1}{$a} <=> $total_methodexecs{$name1}{$b}} keys %{$total_methodexecs{$name1}}) {		
		$tname1 = $name1;
		$tname2 = $name2;
		$tname1 =~ s/\.//g;
		$tname2 =~ s/\.//g;
		print DATA "\\newcommand{\\"."testSubject".$tname1.$tname2."Mexecs} {".$total_methodexecs{$name1}{$name2}."}\n";
	}
}
print DATA "\n";

close(DATA);
print "Finish all LaTex data generation!\n";


#=======================Starting of subroutines ========================
sub getNameWithoutPackage {
	local($name) = @_;
	$ret_name = $name;
	@namewithpath = split(/\./,$name); 
	foreach $i (@namewithpath) {
		$ret_name = $i;
	}
	return $ret_name;
}

sub processMinimizationResultFile {
  local ($file_name, $class_name, $frontend_name, $test_tool_name)= @_;
  open(MINIMIZERESULT, $file_name) || die "opening test minimization result file".$file_name." $!";
  print DATA "%the following test minimization results are for ".$class_name." using ".$frontend_name." on tests generated by ".$test_tool_name." produced from ".$file_name."\n";
  $found = 0;
  while(<MINIMIZERESULT>) {
	  $line = $_;
	  chomp($line);	  
	  if ($line =~ /^#Total tests:\s(\d+)$/) {
		  $total_tests{$class_name}{$test_tool_name} = $1;
	  } elsif ($line =~ /^#Total method executions:\s(\d+)$/) {
		  $total_methodexecs{$class_name}{$test_tool_name} = $1;		  
	  } elsif ($line =~ /^%Redundant tests \(redundant tests\/total tests\):\s(.+)%$/) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
		  print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Prtests"."} {".$1."\\%}"."\n";
		  $found = 1;
	  #} elsif ($line =~ /^%Equivalent method executions \(equivalent method executions\/total method executions\):(.+)%$/) {
	  #	  print DATA"\\newcommand{\\"."testMin".$class_name.$frontend_name.$test_tool_name."Prmexecs"."} {".$1."\\%}"."\n";
	  } elsif ($line =~ /^%Minimized method executions \(minimized method executions\/total method executions\):\s(.+)%$/) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
	  	  print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Pmmexecs"."} {".$1."\\%}"."\n";
	  #} elsif ($line =~ /^%Equivalent object states \(equivalent object states\/total object states\):(.+)%$/) {
	  #	  print DATA"\\newcommand{\\"."testMin".$class_name.$frontend_name.$test_tool_name."Peobjs"."} {".$1."\\%}"."\n";
	  } elsif ($line =~ /^#Non-equivalent object states:\s(.+)$/) {
		#in fact this is used in test generation table
	  	  print DATA"\\newcommand{\\"."testGen".$class_name.$frontend_name.$test_tool_name."OrigNeobjs"."} {".$1."}"."\n";
	  } elsif ($line =~ /^#Non-Redundant tests:\s(.+)$/) {
		#in fact this is used in test generation table
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
	  	  print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Nrtests"."} {".$1."}"."\n";
	  }  
  }

  print DATA "%the following print out the unfound minimization data:\n";
  if ($found == 0) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
	print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Prtests"."} {"."om"."}"."\n";
	#print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Prmexecs"."} {"."om"."}"."\n";
	print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Pmmexecs"."} {"."om"."}"."\n";
	#print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Peobjs"."} {"."om"."}"."\n";
	print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Neobjs"."} {"."om"."}"."\n";
  }

  print DATA "\n";
  close(MINIMIZERESULT);  
}

sub processMinimizationElapsedTimeFile {
  local ($file_name, $class_name, $frontend_name, $test_tool_name) = @_;
  open(ELAPSEDTIME, $file_name) || die "opening test minimization elapsed time file".$file_name." $!";
  print DATA "%the following test minimization elapsed time is for ".$class_name." using ".$frontend_name." on tests generated by ".$test_tool_name." produced from ".$file_name."\n";
  $found = 0;
  while(<ELAPSEDTIME>) {
		$line = $_;
		chomp($line);	  
		if ($line =~ /^Elaspsed time on runtime \+ instrumentation excluding outputting results \(seconds\):(\S+)\ssecond\(s\)$/) {
			$found = 1;
		  	$time = $1;
			if ($time eq "0.0") {
			  $time = "0";
			}
			$tclass_name = $class_name;
			$tclass_name =~ s/\.//g;
		    print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Time"."} {".$time."}"."\n";
	  } 
  }

  print DATA "%the following print out the unfound minimization elapsed time:\n";
  if ($found == 0) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
	print DATA"\\newcommand{\\"."testMin".$tclass_name.$frontend_name.$test_tool_name."Time"."} {"."om"."}"."\n";
  }

  print DATA "\n";
  close(ELAPSEDTIME);
}

sub processGenerationResultFile {
  local ($file_name, $class_name, $frontend_name, $test_tool_name)= @_;
  ##See whether we have accumulative data (in old version, we don't have)
  open(GENERATIONRESULT, $file_name) || die "opening test generation result file".$file_name." $!";
  $has_accumulative_time_data = 0;
  while(<GENERATIONRESULT>) {
	$line = $_;
	chomp($line);
	if ($line =~ /^After iteration (\d+) Elapsed time:\s(\S+) second\(s\)$/) {
		$has_accumulative_time_data = 1;
	}	
  }
  close(GENERATIONRESULT);
  
  open(GENERATIONRESULT, $file_name) || die "opening test generation result file".$file_name." $!";
  print DATA "%the following test generation results are for ".$class_name." using ".$frontend_name." on tests generated by ".$test_tool_name." produced from ".$file_name."\n";  
  %iteration_found = ();
  $iteration_1_time = 0;#used to compute accumulative time
  %iteration_time_out = ();
  $iteration_time_out{1} = 0;
  $iteration_time_out{2} = 0;
  while(<GENERATIONRESULT>) {
	  $line = $_;
	  chomp($line);
	  if ($line =~ /^In iteration (\d) time out:\s(\d)$/) {
		$iteration_num = $1;
		$time_out_flag = $2;
		if (($iteration_num == 1) and ($time_out_flag == 1)) {
			$iteration_time_out{1} = 1;
		} elsif (($iteration_num == 2) and ($time_out_flag == 1)) {
			$iteration_time_out{2} = 1;
		}		
	  } elsif ($line =~ /^After iteration (\d+) #Total tests:\s(\d+)$/) {
		  $iteration_num = $1;
		  if ($iteration_time_out{$iteration_num} == 1) {
			$time_out_prefix = "*";
		  } else {
			$time_out_prefix = "";
		  }
		  if ($iteration_num <= $max_iteration) {
			  $iteration_found{$iteration_num} = 1;
			  if ($iteration_num == 1) {
				  $iteration_num = "One";
			  } elsif ($iteration_num == 2) {
				  $iteration_num = "Two";
			  }
			$tclass_name = $class_name;
			$tclass_name =~ s/\.//g;
			  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Tests"."} {".$time_out_prefix.$2."}"."\n";
		  }		  
	  } elsif ($line =~ /^After iteration (\d+) #Total method executions:\s(\d+)$/) {
		  $iteration_num = $1;
		  if ($iteration_time_out{$iteration_num} == 1) {
			$time_out_prefix = "*";
		  } else {
			$time_out_prefix = "";
		  }
		  if ($iteration_num <= $max_iteration) {
			  $iteration_found{$iteration_num} = 1;
			  if ($iteration_num == 1) {
				  $iteration_num = "One";
			  } elsif ($iteration_num == 2) {
				  $iteration_num = "Two";
			  }
			$tclass_name = $class_name;
			$tclass_name =~ s/\.//g;
			  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Mexecs"."} {".$time_out_prefix.$2."}"."\n";
		  }		  
	  } elsif ($line =~ /^After iteration (\d+) #Non-equivalent object states:\s(\d+)$/) {
		  $iteration_num = $1;
		  if ($iteration_time_out{$iteration_num} == 1) {
			$time_out_prefix = "*";
		  } else {
			$time_out_prefix = "";
		  }		  
		  if ($iteration_num <= $max_iteration) {
			  $iteration_found{$iteration_num} = 1;
			  if ($iteration_num == 1) {
				  $iteration_num = "One";
			  } elsif ($iteration_num == 2) {
				  $iteration_num = "Two";
			  }			  
				$tclass_name = $class_name;
				$tclass_name =~ s/\.//g;
			  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Neobjs"."} {".$time_out_prefix.$2."}"."\n";
		  }		  
	  } elsif ($line =~ /^After iteration (\d+) Elapsed time:\s(\S+) second\(s\)$/) {
		  $iteration_num = $1;		  
		  $time = $2;
		  if ($iteration_num == 1) {
			$iteration_num = "One";
		  } elsif ($iteration_num == 2) {
			$iteration_num = "Two";
		  }			  			 		  
		  if ($iteration_time_out{$iteration_num} == 1) {
			$time_out_prefix = "*";
		  } else {
			$time_out_prefix = "";
		  }
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
		  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Time"."} {".$time_out_prefix.$time."}"."\n";
	  } elsif ($line =~ /^In iteration (\d+) Elapsed time:\s(\S+) second\(s\)$/) {
		  $iteration_num = $1;
		  $time = $2;
		  if ($iteration_time_out{$iteration_num} == 1) {
			$time_out_prefix = "*";
		  } else {
			$time_out_prefix = "";
		  }		  
		  if ($iteration_num <= $max_iteration) {
			  $iteration_found{$iteration_num} = 1;
			  if ($iteration_num == 1) {
				  $iteration_num = "One";
				  $iteration_1_time = $time;
			  } elsif ($iteration_num == 2) {
				  $iteration_num = "Two";
				  $time = $iteration_1_time + $time;#we use accumulative time in our result
			  }			  			  
			  if ($time eq "0.0") {
				  $time = "0";
			  }
			  if ($has_accumulative_time_data == 0) {
				$tclass_name = $class_name;
				$tclass_name =~ s/\.//g;
				print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Time"."} {".$time_out_prefix.$time."}"."\n";
			  }
		  }		  
	  }
  }
  print DATA "%the following print out the unfound iteration data:\n";
  for($i=1;$i<=$max_iteration; $i++) {
	  if (not (exists $iteration_found{$i})) {
 			 if ($i == 1) {
				  $iteration_num = "One";
			  } elsif ($i == 2) {
				  $iteration_num = "Two";
			  }
			$tclass_name = $class_name;
			$tclass_name =~ s/\.//g;
		  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Tests"."} {"."om"."}"."\n";
		  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Neobjs"."} {"."om"."}"."\n";
		  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Mexecs"."} {"."om"."}"."\n";
		  print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Iteration".$iteration_num."Time"."} {"."om"."}"."\n";
	  }
  }
  
  print DATA "\n";
  close(GENERATIONRESULT);  
}

sub processBCovExceptionFile {
  local ($file_name, $class_name, $frontend_name, $test_tool_name, $test_type)= @_;
  open(GENERATIONRESULT, $file_name) || die "opening branch coverage/exception result file".$file_name." $!";
  $tclass_name = $class_name;
  $tclass_name =~ s/\.//g;

  $frontend_name = &getActualFrontEndName($frontend_name);
  print DATA "%the following branch coverarge/exception results are for ".$class_name." using ".$frontend_name." on tests generated by ".$test_tool_name." produced from ".$file_name."\n";
  $has_result = 0;
  while(<GENERATIONRESULT>) {
	  $line = $_;
	  chomp($line);	  
	  if ($line =~ /branches covered]:\s(.+)%$/) {
		$has_result = 1;
		$metrics_type = "BCov";
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;

		if ($test_type == $ORIG_TESTS) {
			#for orig tests, the $frontend_name is ""
			foreach $actual_frontend_name (keys %frontend_has_results) {	
				#print DATA"\\newcommand{\\"."testGen".$tclass_name.$actual_frontend_name.$test_tool_name."Orig".$metrics_type."} {".$1."\\%}"."\n";
				$result = $1;
				#if ($result =~/^(\d*)\.(\d*)/) {
				#	$result = $1;
				#}
				print DATA"\\newcommand{\\"."testGen".$tclass_name.$actual_frontend_name.$test_tool_name."Orig".$metrics_type."} {".sprintf("%.0f", $result)."}"."\n";
			}			
		} elsif ($test_type == $MINIMIZED_TESTS) {
			#we don't use in output, since it is supposed to be the same as orignal tests
			print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Min".$metrics_type."} {".$1."\\%}"."\n";
		} elsif ($test_type == $GENERATED_ITERATION_1) {
			print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {".$1."\\%}"."\n";
		} elsif ($test_type == $GENERATED_ITERATION_2) {
			print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {".$1."\\%}"."\n";
		}
	  } elsif ($line =~ /#non-equivalent thrown uncaught exceptions:\s(\d+)$/) {
		$metrics_type = "Exceptions";
		if ($test_type == $ORIG_TESTS) {
			#for orig tests, the $frontend_name is ""
			foreach $actual_frontend_name (keys %frontend_has_results) {	
				print DATA"\\newcommand{\\"."testGen".$tclass_name.$actual_frontend_name.$test_tool_name."Orig".$metrics_type."} {".$1."}"."\n";
			}						
		} elsif ($test_type == $MINIMIZED_TESTS) {
			#we don't use in output, since it is supposed to be the same as orignal tests
			print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Min".$metrics_type."} {".$1."}"."\n";
		} elsif ($test_type == $GENERATED_ITERATION_1) {
			print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {".$1."}"."\n";
		} elsif ($test_type == $GENERATED_ITERATION_2) {
			print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {".$1."}"."\n";
		}
	  } elsif ($line =~ /Total tests:\s(\d+)$/) {
		$metrics_type = "TotalTestsInCov";
		if ($test_type == $ORIG_TESTS) {
			#for orig tests, the $frontend_name is ""
			foreach $actual_frontend_name (keys %frontend_has_results) {	
				print DATA"\\newcommand{\\"."testGen".$class_name.$actual_frontend_name.$test_tool_name."Orig".$metrics_type."} {".$1."}"."\n";
			}						
		} elsif ($test_type == $MINIMIZED_TESTS) {
			#we don't use in output, since it is supposed to be the same as orignal tests
			print DATA"\\newcommand{\\"."testGen".$class_name.$frontend_name.$test_tool_name."Min".$metrics_type."} {".$1."}"."\n";
		} elsif ($test_type == $GENERATED_ITERATION_1) {
			print DATA"\\newcommand{\\"."testGen".$class_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {".$1."}"."\n";
		} elsif ($test_type == $GENERATED_ITERATION_2) {
			print DATA"\\newcommand{\\"."testGen".$class_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {".$1."}"."\n";
		}
	  }
  }
  if (!$has_result) {
		$tclass_name = $class_name;
		$tclass_name =~ s/\.//g;
	if ($test_type == $ORIG_TESTS) {
		$metrics_type = "BCov";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Orig".$metrics_type."} {"."om"."}"."\n";		
		$metrics_type = "Exceptions";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Orig".$metrics_type."} {"."om"."}"."\n";		
	} elsif ($test_type == $MINIMIZED_TESTS) {
		#we don't use in output, since it is supposed to be the same as orignal tests
		$metrics_type = "BCov";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Min".$metrics_type."} {"."om"."}"."\n";
		$metrics_type = "Exceptions";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."Min".$metrics_type."} {"."om"."}"."\n";
	} elsif ($test_type == $GENERATED_ITERATION_1) {
		$metrics_type = "BCov";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {"."om"."}"."\n";
		$metrics_type = "Exceptions";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationOne".$metrics_type."} {"."om"."}"."\n";
	} elsif ($test_type == $GENERATED_ITERATION_2) {
		$metrics_type = "BCov";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {"."om"."}"."\n";
		$metrics_type = "Exceptions";
		print DATA"\\newcommand{\\"."testGen".$tclass_name.$frontend_name.$test_tool_name."IterationTwo".$metrics_type."} {"."om"."}"."\n";
	}	
  }
  print DATA "\n";
  close(GENERATIONRESULT);  
}
  
  sub getActualFrontEndName {
  
	  local ($orig_frontend_name)= @_;
	  if ($orig_frontend_name =~/pairwiseEquals/) {
		  return "pairwiseEquals";
	  } elsif ($orig_frontend_name =~/monitorEquals/) {
		  return "monitorEquals";
	  } elsif ($orig_frontend_name =~/monitorWField/) {
		 return "monitorWField";
	  } elsif ($orig_frontend_name =~/traverseField/) {
		 return "traverseField";
	  } elsif ($orig_frontend_name =~/monitorSMSeq/) {
		 return "monitorSMSeq";
	  } elsif ($orig_frontend_name =~/monitorSeq/) {
		 return "monitorSeq";
	  }
	  return "";
  }


$frontend_has_results{"pairwiseEquals"}{"TestMin"} = 0;
$frontend_has_results{"monitorEquals"}{"TestMin"} = 0;
$frontend_has_results{"monitorWField"}{"TestMin"} = 0;
$frontend_has_results{"traverseField"}{"TestMin"} = 0;
$frontend_has_results{"monitorSMSeq"}{"TestMin"} = 0;
$frontend_has_results{"monitorSeq"}{"TestMin"} = 0;
$frontend_has_results{"pairwiseEquals"}{"TestGen"} = 0;
$frontend_has_results{"monitorEquals"}{"TestGen"} = 0;
$frontend_has_results{"monitorWField"}{"TestGen"} = 0;
$frontend_has_results{"traverseField"}{"TestGen"} = 0;
$frontend_has_results{"monitorSMSeq"}{"TestGen"} = 0;
$frontend_has_results{"monitorSeq"}{"TestGen"} = 0;
