#!/usr/bin/perl  -w
use Cwd;

$skeleton_file_name = "skeleton.tex";

#%UBS BSet BBag Book Library ShoppingCart BankAccount BinarySearchTree LinkedList
%subject_names = ();
$subject_names{"IntStack"} = 0;
$subject_names{"uniqueBoundedStack"} = 1;
$subject_names{"ShoppingCart"} = 2;
$subject_names{"BankAccount"} = 3;
$subject_names{"BinarySearchTree"} = 4;
$subject_names{"BinomialHeap"} = 5;
$subject_names{"DisjSet"} = 6;
$subject_names{"FibonacciHeap"} = 7;
$subject_names{"HashMap"} = 8;
$subject_names{"LinkedList"} = 9;
$subject_names{"TreeMap"} = 10;

%subject_item_names = ();
$subject_item_names{"Tests"} = 0;
$subject_item_names{"Mexecs"} = 1;


%technique_names = ();
$technique_names{"pairwiseEquals"} = 0;
$technique_names{"monitorEquals"} = 1;
$technique_names{"monitorWField"} = 2;
$technique_names{"traverseField"} = 3;
$technique_names{"monitorSMSeq"} = 4;
$technique_names{"monitorSeq"} = 5;

%tool_names = ();
$tool_names{"Jtest"} = 0;
$tool_names{"JCrasher"} = 1;

## for test minimization result table
%testmin_item_names = ();
$testmin_item_names{"Prtests"} = 0;
$testmin_item_names{"Pmmexecs"} = 1;
$testmin_item_names{"Time"} = 3;

## for test generation result table
%testgen_iteration_nums = ();
$testgen_iteration_nums{"Orig"} = 0;
$testgen_iteration_nums{"IterationOne"} = 1;
$testgen_iteration_nums{"IterationTwo"} = 2;

## for performance statistics table
%testgen1_item_names = ();
$testgen1_item_names{"Tests"} = 0;
$testgen1_item_names{"Mexecs"} = 1;
$testgen1_item_names{"Neobjs"} = 2;
$testgen1_item_names{"Time"} = 5;
## for effectiveness statistics table
$testgen2_item_names{"Exceptions"} = 3;
$testgen2_item_names{"BCov"} = 4;

open(SKELETON, ">".$skeleton_file_name) || die "opening skeleton file".$skeleton_file_name." $!";

print SKELETON "%the following is for imported data files"."\n";
foreach $name1 (sort {$subject_names{$a} <=> $subject_names{$b}} keys %subject_names) {
	print SKELETON "\\input{"."koratresults/".$name1."/jcrasher/"."data}\n";
	print SKELETON "\\input{"."koratresults/".$name1."/jtest/"."data}\n";
}
print SKELETON "\n";


print SKELETON "%the following is for subject table"."\n";
foreach $name1 (sort {$subject_names{$a} <=> $subject_names{$b}} keys %subject_names) {
	print SKELETON "\\newcommand{\\testSubject".$name1."} {\n";
	foreach $name2 (sort {$tool_names{$a} <=> $tool_names{$b}} keys %tool_names) {		
		foreach $name3 (sort {$subject_item_names{$a} <=> $subject_item_names{$b}} keys %subject_item_names) {
			print SKELETON "&\\"."testSubject".$name1.$name2.$name3."\n";
		}		
	}
	print SKELETON "}\n";
}
print SKELETON "\n";


print SKELETON "%the following is for test minimization table"."\n";
foreach $name1 (sort {$subject_names{$a} <=> $subject_names{$b}} keys %subject_names) {
	foreach $name2 (sort {$technique_names{$a} <=> $technique_names{$b}} keys %technique_names) {
		print SKELETON "\\newcommand{\\testMin".$name1.$name2."} {\n";
		foreach $name3 (sort {$tool_names{$a} <=> $tool_names{$b}} keys %tool_names) {
			foreach $name4 (sort {$testmin_item_names{$a} <=> $testmin_item_names{$b}} keys %testmin_item_names) {
				print SKELETON "&\\"."testMin".$name1.$name2.$name3.$name4."\n";
			}
		}
		print SKELETON "}\n";
	}
}
print SKELETON "\n";

print SKELETON "%the following is for test generation performance statistics table table"."\n";
foreach $name1 (sort {$subject_names{$a} <=> $subject_names{$b}} keys %subject_names) {
	foreach $name2 (sort {$technique_names{$a} <=> $technique_names{$b}} keys %technique_names) {		
		foreach $name3 (sort {$tool_names{$a} <=> $tool_names{$b}} keys %tool_names) {
			print SKELETON "\\newcommand{\\testGenPerf".$name1.$name2.$name3."} {\n";
			foreach $name4 (sort {$testgen1_item_names{$a} <=> $testgen1_item_names{$b}} keys %testgen1_item_names) {
				foreach $name5 (sort {$testgen_iteration_nums{$a} <=> $testgen_iteration_nums{$b}} keys %testgen_iteration_nums) {
					if (($name4 eq "Time") and ($name5 eq "Orig")) {#we don't generate original entry for "time"
						next;
					} else {
						print SKELETON "&\\"."testGen".$name1.$name2.$name3.$name5.$name4."\n";
					}
				}
			}
			print SKELETON "}\n";
		}		
	}
}
print SKELETON "\n";

print SKELETON "%the following is for test generation performance statistics table table"."\n";
foreach $name1 (sort {$subject_names{$a} <=> $subject_names{$b}} keys %subject_names) {
	foreach $name2 (sort {$technique_names{$a} <=> $technique_names{$b}} keys %technique_names) {		
		foreach $name3 (sort {$tool_names{$a} <=> $tool_names{$b}} keys %tool_names) {
			print SKELETON "\\newcommand{\\testGenEff".$name1.$name2.$name3."} {\n";
			foreach $name4 (sort {$testgen2_item_names{$a} <=> $testgen2_item_names{$b}} keys %testgen2_item_names) {
				foreach $name5 (sort {$testgen_iteration_nums{$a} <=> $testgen_iteration_nums{$b}} keys %testgen_iteration_nums) {
					if (($name4 eq "Time") and ($name5 eq "Orig")) {#we don't generate original entry for "time"
						next;
					} else {
						print SKELETON "&\\"."testGen".$name1.$name2.$name3.$name5.$name4."\n";
					}
				}
			}
			print SKELETON "}\n";
		}		
	}
}
print SKELETON "\n";


#We don't use this style
#print SKELETON "%the following is for original test information in test generation table"."\n";
#foreach $name1 (sort {$subject_names{$a} <=> $subject_names{$b}} keys %subject_names) {
#	$name2 = "Orig";		
#	foreach $name3 (sort {$tool_names{$a} <=> $tool_names{$b}} keys %tool_names) {
#		print SKELETON "\\newcommand{\\testGen".$name1.$name2.$name3."} {\n";
#		foreach $name4 (sort {$testgen1_item_names{$a} <=> $testgen1_item_names{$b}} keys %testgen1_item_names) {
#			print SKELETON "&\\"."testGen".$name1.$name2.$name3.$name4."\n";
#			print SKELETON "&"."\n";#empty
#		}
#		print SKELETON "}\n";
#	}		
#}
#print SKELETON "\n";


close(SKELETON);
print "finishing skeleton generation!\n";